# keystoneclient.auth.identity.generic package

## Submodules

## keystoneclient.auth.identity.generic.base module

class keystoneclient.auth.identity.generic.base.BaseGenericPlugin(auth_url, tenant_id=None, tenant_name=None, project_id=None, project_name=None, project_domain_id=None, project_domain_name=None, domain_id=None, domain_name=None, trust_id=None)

  Bases: `BaseIdentityPlugin`

  An identity plugin that is not version dependent.

  Internally we will construct a version dependent plugin with the resolved URL and then proxy all calls from the base plugin to the versioned one.

  abstractmethod create_plugin(session, version, url, raw_status=None)

    Create a plugin from the given parameters.

    This function will be called multiple times with the version and url of a potential endpoint. If a plugin can be constructed that fits the params then it should return it. If not return None and then another call will be made with other available URLs.

    Parameters:

      - session (keystoneclient.session.Session) – A session object.

      - version (tuple) – A tuple of the API version at the URL.

      - url (string) – The base URL for this version.

      - raw_status (string) – The status that was in the discovery field.

    Returns:

      A plugin that can match the parameters or None if nothing.

  get_auth_ref(session, **kwargs)

    Obtain a token from an OpenStack Identity Service.

    This method is overridden by the various token version plugins.

    This method should not be called independently and is expected to be invoked via the do_authenticate() method.

    This method will be invoked if the AccessInfo object cached by the plugin is not valid. Thus plugins should always fetch a new AccessInfo when invoked. If you are looking to just retrieve the current auth data then you should use get_access().

    Parameters:

      session (keystoneclient.session.Session) – A session object that can be used for communication.

    Raises:

      - keystoneclient.exceptions.InvalidResponse – The response returned wasn’t appropriate.

      - keystoneclient.exceptions.HttpError – An error from an invalid HTTP response.

    Returns:

      Token access information.

    Return type:

      `keystoneclient.access.AccessInfo`

  classmethod get_options()

    Return the list of parameters associated with the auth plugin.

    This list may be used to generate CLI or config arguments.

    Returns:

      A list of Param objects describing available plugin parameters.

    Return type:

      List

  property trust_id

    Deprecated as of the 1.7.0 release.

    It may be removed in the 2.0.0 release.

keystoneclient.auth.identity.generic.base.get_options()

## keystoneclient.auth.identity.generic.cli module

class keystoneclient.auth.identity.generic.cli.DefaultCLI(endpoint=None, token=None, **kwargs)

  Bases: `Password`

  A Plugin that provides typical authentication options for CLIs.

  This plugin provides standard username and password authentication options as well as allowing users to override with a custom token and endpoint.

  get_endpoint(*args, **kwargs)

    Return a valid endpoint for a service.

    If a valid token is not present then a new one will be fetched using the session and kwargs.

    Parameters:

      - session (keystoneclient.session.Session) – A session object that can be used for communication.

      - service_type (string) – The type of service to lookup the endpoint for. This plugin will return None (failure) if service_type is not provided.

      - interface (string) – The exposure of the endpoint. Should be public, internal, admin, or auth. auth is special here to use the auth_url rather than a URL extracted from the service catalog. Defaults to public.

      - region_name (string) – The region the endpoint should exist in. (optional)

      - service_name (string) – The name of the service in the catalog. (optional)

      - version (tuple) – The minimum version number required for this endpoint. (optional)

    Raises:

      keystoneclient.exceptions.HttpError – An error from an invalid HTTP response.

    Returns:

      A valid endpoint URL or None if not available.

    Return type:

      string or None

  classmethod get_options()

    Return the list of parameters associated with the auth plugin.

    This list may be used to generate CLI or config arguments.

    Returns:

      A list of Param objects describing available plugin parameters.

    Return type:

      List

  get_token(*args, **kwargs)

    Return a valid auth token.

    If a valid token is not present then a new one will be fetched.

    Parameters:

      session (keystoneclient.session.Session) – A session object that can be used for communication.

    Raises:

      keystoneclient.exceptions.HttpError – An error from an invalid HTTP response.

    Returns:

      A valid token.

    Return type:

      string

  classmethod load_from_argparse_arguments(namespace, **kwargs)

    Load a specific plugin object from an argparse result.

    Convert the results of a parse into the specified plugin.

    Parameters:

      namespace (argparse.Namespace) – The result from CLI parsing.

    Returns:

      An auth plugin, or None if a name is not provided.

    Return type:

      `keystoneclient.auth.BaseAuthPlugin`

## keystoneclient.auth.identity.generic.password module

class keystoneclient.auth.identity.generic.password.Password(auth_url, username=None, user_id=None, password=None, user_domain_id=None, user_domain_name=None, **kwargs)

  Bases: `BaseGenericPlugin`

  A common user/password authentication plugin.

  Parameters:

    - username (string) – Username for authentication.

    - user_id (string) – User ID for authentication.

    - password (string) – Password for authentication.

    - user_domain_id (string) – User’s domain ID for authentication.

    - user_domain_name (string) – User’s domain name for authentication.

  create_plugin(session, version, url, raw_status=None)

    Create a plugin from the given parameters.

    This function will be called multiple times with the version and url of a potential endpoint. If a plugin can be constructed that fits the params then it should return it. If not return None and then another call will be made with other available URLs.

    Parameters:

      - session (keystoneclient.session.Session) – A session object.

      - version (tuple) – A tuple of the API version at the URL.

      - url (string) – The base URL for this version.

      - raw_status (string) – The status that was in the discovery field.

    Returns:

      A plugin that can match the parameters or None if nothing.

  classmethod get_options()

    Return the list of parameters associated with the auth plugin.

    This list may be used to generate CLI or config arguments.

    Returns:

      A list of Param objects describing available plugin parameters.

    Return type:

      List

  classmethod load_from_argparse_arguments(namespace, **kwargs)

    Load a specific plugin object from an argparse result.

    Convert the results of a parse into the specified plugin.

    Parameters:

      namespace (argparse.Namespace) – The result from CLI parsing.

    Returns:

      An auth plugin, or None if a name is not provided.

    Return type:

      `keystoneclient.auth.BaseAuthPlugin`

keystoneclient.auth.identity.generic.password.get_options()

## keystoneclient.auth.identity.generic.token module

class keystoneclient.auth.identity.generic.token.Token(auth_url, token=None, **kwargs)

  Bases: `BaseGenericPlugin`

  Generic token auth plugin.

  Parameters:

    token (string) – Token for authentication.

  create_plugin(session, version, url, raw_status=None)

    Create a plugin from the given parameters.

    This function will be called multiple times with the version and url of a potential endpoint. If a plugin can be constructed that fits the params then it should return it. If not return None and then another call will be made with other available URLs.

    Parameters:

      - session (keystoneclient.session.Session) – A session object.

      - version (tuple) – A tuple of the API version at the URL.

      - url (string) – The base URL for this version.

      - raw_status (string) – The status that was in the discovery field.

    Returns:

      A plugin that can match the parameters or None if nothing.

  classmethod get_options()

    Return the list of parameters associated with the auth plugin.

    This list may be used to generate CLI or config arguments.

    Returns:

      A list of Param objects describing available plugin parameters.

    Return type:

      List

keystoneclient.auth.identity.generic.token.get_options()

## Module contents

class keystoneclient.auth.identity.generic.BaseGenericPlugin(auth_url, tenant_id=None, tenant_name=None, project_id=None, project_name=None, project_domain_id=None, project_domain_name=None, domain_id=None, domain_name=None, trust_id=None)

  Bases: `BaseIdentityPlugin`

  An identity plugin that is not version dependent.

  Internally we will construct a version dependent plugin with the resolved URL and then proxy all calls from the base plugin to the versioned one.

  abstractmethod create_plugin(session, version, url, raw_status=None)

    Create a plugin from the given parameters.

    This function will be called multiple times with the version and url of a potential endpoint. If a plugin can be constructed that fits the params then it should return it. If not return None and then another call will be made with other available URLs.

    Parameters:

      - session (keystoneclient.session.Session) – A session object.

      - version (tuple) – A tuple of the API version at the URL.

      - url (string) – The base URL for this version.

      - raw_status (string) – The status that was in the discovery field.

    Returns:

      A plugin that can match the parameters or None if nothing.

  get_auth_ref(session, **kwargs)

    Obtain a token from an OpenStack Identity Service.

    This method is overridden by the various token version plugins.

    This method should not be called independently and is expected to be invoked via the do_authenticate() method.

    This method will be invoked if the AccessInfo object cached by the plugin is not valid. Thus plugins should always fetch a new AccessInfo when invoked. If you are looking to just retrieve the current auth data then you should use get_access().

    Parameters:

      session (keystoneclient.session.Session) – A session object that can be used for communication.

    Raises:

      - keystoneclient.exceptions.InvalidResponse – The response returned wasn’t appropriate.

      - keystoneclient.exceptions.HttpError – An error from an invalid HTTP response.

    Returns:

      Token access information.

    Return type:

      `keystoneclient.access.AccessInfo`

  classmethod get_options()

    Return the list of parameters associated with the auth plugin.

    This list may be used to generate CLI or config arguments.

    Returns:

      A list of Param objects describing available plugin parameters.

    Return type:

      List

  property trust_id

    Deprecated as of the 1.7.0 release.

    It may be removed in the 2.0.0 release.

class keystoneclient.auth.identity.generic.Password(auth_url, username=None, user_id=None, password=None, user_domain_id=None, user_domain_name=None, **kwargs)

  Bases: `BaseGenericPlugin`

  A common user/password authentication plugin.

  Parameters:

    - username (string) – Username for authentication.

    - user_id (string) – User ID for authentication.

    - password (string) – Password for authentication.

    - user_domain_id (string) – User’s domain ID for authentication.

    - user_domain_name (string) – User’s domain name for authentication.

  create_plugin(session, version, url, raw_status=None)

    Create a plugin from the given parameters.

    This function will be called multiple times with the version and url of a potential endpoint. If a plugin can be constructed that fits the params then it should return it. If not return None and then another call will be made with other available URLs.

    Parameters:

      - session (keystoneclient.session.Session) – A session object.

      - version (tuple) – A tuple of the API version at the URL.

      - url (string) – The base URL for this version.

      - raw_status (string) – The status that was in the discovery field.

    Returns:

      A plugin that can match the parameters or None if nothing.

  classmethod get_options()

    Return the list of parameters associated with the auth plugin.

    This list may be used to generate CLI or config arguments.

    Returns:

      A list of Param objects describing available plugin parameters.

    Return type:

      List

  classmethod load_from_argparse_arguments(namespace, **kwargs)

    Load a specific plugin object from an argparse result.

    Convert the results of a parse into the specified plugin.

    Parameters:

      namespace (argparse.Namespace) – The result from CLI parsing.

    Returns:

      An auth plugin, or None if a name is not provided.

    Return type:

      `keystoneclient.auth.BaseAuthPlugin`

class keystoneclient.auth.identity.generic.Token(auth_url, token=None, **kwargs)

  Bases: `BaseGenericPlugin`

  Generic token auth plugin.

  Parameters:

    token (string) – Token for authentication.

  create_plugin(session, version, url, raw_status=None)

    Create a plugin from the given parameters.

    This function will be called multiple times with the version and url of a potential endpoint. If a plugin can be constructed that fits the params then it should return it. If not return None and then another call will be made with other available URLs.

    Parameters:

      - session (keystoneclient.session.Session) – A session object.

      - version (tuple) – A tuple of the API version at the URL.

      - url (string) – The base URL for this version.

      - raw_status (string) – The status that was in the discovery field.

    Returns:

      A plugin that can match the parameters or None if nothing.

  classmethod get_options()

    Return the list of parameters associated with the auth plugin.

    This list may be used to generate CLI or config arguments.

    Returns:

      A list of Param objects describing available plugin parameters.

    Return type:

      List

this page last updated: 2026-04-01 09:38:00

Except where otherwise noted, this document is licensed under Creative Commons Attribution 3.0 License. See all OpenStack Legal Documents.

found an error? report a bug